// */**********************************************************************\*
// **                                                                      **
// ** Licensed Materials - Property of IBM                                 **
// ** (C) Copyright IBM Corp. 2005, 2007  All Rights Reserved.             **
// **                                                                      **
// ** US Government Users Restricted Rights - Use, duplication, or         **
// ** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.    **
// **                                                                      **
// *\**********************************************************************/*
//searchManagerSelect.js
/*
 * Code  Reason   Rlse     Date    Origin   Comments                         
 * ----- -------- -------- ------- -------- --------------------------------
 * $D1   157033   612      081031  THAMM    Moved common methods to search.js
 * $D2   157224   612      081117  BREIT    Store search results to user-defined place
 * $D3   157342   6200     090402  POD      errorMessage: 'null' is null or not an object
 * $D4   157343   6200     090409  POD      Relationship radio button in "Group 
 *                                           Properties"  is unnecessary
 */

var searchListsData = null;
var radioFileType = 'html'
var ss = null;
var cache = null;
var searchAjax = null;
var propertiesArray = new Array();
var subClassesMenu = new Array();
var localFile = 'false';
var convReport = null;


var directory;

var searchBarRef = 'searchBar' //required for search porgress bar

function subClassesObject()
    {
    this.name
    this.id
    this.list
    }

function classPropObject()
    {
    this.name
    this.type
    this.list
    }

function tagPropObject()
    {
    this.name
    this.type
    this.list
    }

function groupPropObject()
    {
    this.name
    this.type
    this.list
    }

function requestSearchLists(searchUrl, searchParameters) {
    try {
    	logger.trace('requestSearchLists(...) has been called');
        if (window.opener) {
            var searchReplayMode = window.opener.replayMode;
            var searchReplayID = window.opener.replayID;

            if (searchReplayMode) {
                searchParameters += '&replayid=' + searchReplayID;
            }
        }

		var ajax = new AjaxHandler();
		ajax.sendRequest(searchUrl, searchParameters, false, parseSearchLists);
    }
    catch (errorObject) {
        handleException(errorObject, arguments, 'requestSearchLists', 'searchManagerSelect.js');
    }
    logger.trace('requestSearchLists(...) will be left');
}

function parseSearchLists(searchListsMenu) {
    try {
    	logger.trace('parseSearchLists(...) has been called');
	    var getlist, i, searchClassName, displayName;
	    clearClassesDropMenus();
	    classes.classesMenu.options[classes.classesMenu.options.length] = new Option('All', 'All');
	    classes.classesMenu.selectedIndex = 0;
	    subClasses.subClassesMenu.options[subClasses.subClassesMenu.options.length] = new Option('All', 'All');
	    subClasses.subClassesMenu.selectedIndex = 0;
	    var getList = searchListsMenu.getElementsByTagName("classes");
	    var cNode = getList[0].childNodes;
	    if (cNode.length > 0) {
	        for (var i = 0; i < cNode.length; i++) {
	            var propNode = cNode[i].childNodes;
	            searchClassName = cNode[i].getAttribute("name");
	            classId = cNode[i].getAttribute("id");
	            displayName = searchClassName;
	            classes.classesMenu.options[classes.classesMenu.options.length] = new Option(displayName, classId);
	            var classesParameters = new Array;
	
	            if (propNode.length > 0) {
	                for (var x = 0; x < propNode.length; x++) {
	                    if (propNode[x].tagName == 'Property') {
	                        var propForm = new classPropObject();
	                        propForm.name = propNode[x].getAttribute("name");
	                        propForm.type = propNode[x].getAttribute("type");
	                        propForm.list = propNode[x].getAttribute("list");
	                        classesParameters[x] = propForm;
                        }
                    }
	                propertiesArray[searchClassName] = classesParameters;
                }
	
	            var scNode = cNode[i].getElementsByTagName("class");
	
	            if (scNode.length > 0) {
	                var subClassesArray = new Array;
	
	                for (var j = 0; j < scNode.length; j++) {
	                    var cName = scNode[j].getAttribute("name");
	                    displayName = searchClassName;
	                    var scMenu = new subClassesObject();
	                    scMenu.name = scNode[j].getAttribute("name");
	                    scMenu.id = scNode[j].getAttribute("id");
	                    subClassesArray[j] = scMenu;
	                    //var propNode = scNode[j].getElementsByTagName("Property");
	                    var propNode = scNode[j].childNodes;
	                    var subClassesParameters = new Array;
	
	                    if (propNode.length > 0) {
	                        for (var z = 0; z < propNode.length; z++) {
	                        	if (propNode[z].tagName == 'Property') {
		                            var propForm = new classPropObject()
		                            propForm.name = propNode[z].getAttribute("name");
		                            propForm.type = propNode[z].getAttribute("type");
		                            propForm.list = propNode[z].getAttribute("list");
		                            subClassesParameters[z] = propForm
	                            }
                            }
	
	                        propertiesArray[cName] = subClassesParameters;
                        }
	                    subClassesMenu[cNode[i].getAttribute("name")] = subClassesArray;
                    }
                }
            }
        }
	    var gNode = searchListsMenu.getElementsByTagName("group");
	
	    if (gNode.length > 0) {
	        clearGroupsDropMenus();
	        groups.groupsMenu.options[groups.groupsMenu.options.length] = new Option('All', 'All');
	        groups.groupsMenu.selectedIndex = 0;
logger.debug("Groups");
	        for (var i = 0; i < gNode.length; i++) {
	            groupName = gNode[i].getAttribute("name");
	            groupId = gNode[i].getAttribute("id");
	            displayName = groupName;
logger.debug("adding group: " + groupName);
	            groups.groupsMenu.options[groups.groupsMenu.options.length] = new Option(groupName, groupId);
	            var groupNode = gNode[i].getElementsByTagName("Property");
	            var groupParameters = new Array;
	
	            if (groupNode.length > 0) {
	                for (var z = 0; z < groupNode.length; z++) {
	                    var propForm = new groupPropObject();
	                    propForm.name = groupNode[z].getAttribute("name");
	                    propForm.type = groupNode[z].getAttribute("type");
	                    propForm.list = groupNode[z].getAttribute("list");
	                    groupParameters[z] = propForm;
                    }
	                propertiesArray[groupName + '_group'] = groupParameters;
                }
            }
        }
	    var tNode = searchListsMenu.getElementsByTagName("tag");
	    var tagNode = tNode[0].getElementsByTagName("Property");
	    var tagParameters = new Array;
	
	    if (tagNode.length > 0) {
	        clearTagDropMenus();
	        tags.tagsMenu.options[tags.tagsMenu.options.length] = new Option('All', 'All');
	        tags.tagsMenu.options[tags.tagsMenu.options.length] = new Option('Tag', 'tag');
	        tags.tagsMenu.selectedIndex = 0;
	
	        for (var i = 0; i < tagNode.length; i++) {
	            var tagsForm = new tagPropObject();
	            tagsForm.name = tagNode[i].getAttribute("name");
	            tagsForm.type = tagNode[i].getAttribute("type");
	            tagsForm.list = tagNode[i].getAttribute("list");
	            tagParameters[i] = tagsForm;
            }	
	        propertiesArray['Tag'] = tagParameters;
        }
	}
    catch (errorObject) {
        handleException(errorObject, arguments, 'parseSearchLists', 'searchManagerSelect.js');
    }
   	logger.trace('parseSearchLists(...) will be left');
}

function clearClassesDropMenus() {
    try {
    	logger.trace('clearClassesDropMenus() has been called');
	    var length, i;
	    document.getElementById('classesMenu').options.length = 0
	    length = document.getElementById('classesMenu').options.length
	
	    if (length > 0) {
	        for (i = 0; i < length; i++) {
	            document.getElementById('classesMenu').options[i] = null;
            }
        }
    }
    catch(errorObject) {
        handleException(errorObject, arguments, 'clearClassesDropMenus', 'searchManagerSelect.js');
    }
   	logger.trace('clearClassesDropMenus() will be left');
}

function clearSubClassesDropMenus() {
	try {
    	logger.trace('clearSubClassesDropMenus() has been called');
	    var length, i;
	
	    length = document.getElementById('subClassesMenu').options.length
	
	    if (length > 0) {
	        for (i = 0; i < length; i++) {
	            document.getElementById('subClassesMenu').options[i] = null;
	        }
	    }
	
	    document.getElementById('subClassesMenu').options.length = 0
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'clearSubClassesDropMenus', 'searchManagerSelect.js');
    }
   	logger.trace('clearSubClassesDropMenus() will be left');
}

function clearGroupsDropMenus() {
	try {
    	logger.trace('clearClassesDropMenus() has been called');
	    var length, i;
	    document.getElementById('groupsMenu').options.length = 0
	    length = document.getElementById('groupsMenu').options.length
	
	    if (length > 0) {
	        for (i = 0; i < length; i++) {
	            document.getElementById('groupsMenu').options[i] = null;
            }
        }
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'clearClassesDropMenus', 'searchManagerSelect.js');
    }
   	logger.trace('clearClassesDropMenus() will be left');
}

function clearTagDropMenus() {
    try {
    	logger.trace('clearTagDropMenus() has been called');
	    var length, i;
	    document.getElementById('tagsMenu').options.length = 0
	    length = document.getElementById('tagsMenu').options.length
	
	    if (length > 0) {
	        for (i = 0; i < length; i++) {
	            document.getElementById('tagsMenu').options[i] = null;
            }
        }
    }
	catch(errorObejct) {
		handleException(errorObejct, arguments, 'clearTagDropMenus', 'searchManagerSelect.js');
	}
	logger.trace('clearTagDropMenus() will be left');
}

function classesSelect() {
	try {
    	logger.trace('classesSelect() has been called');
	    var classSelected = classes.classesMenu.options[classes.classesMenu.selectedIndex].text
	
	    if (classSelected == 'All') {
	        clearSubClassesDropMenus();
	        var detailId = document.getElementById('classInput');
	
	        if (detailId != null) {
	            document.getElementById('tCell' + 'classInput').removeChild(document.getElementById('classInput'))
	        }
	
	        subClasses.subClassesMenu.options[subClasses.subClassesMenu.options.length] = new Option('All', 'All')
	        subClasses.subClassesMenu.selectedIndex = 0
	        return
	    }
	
	    createSubClassMenu(classSelected)
	    createInputFields('classInput', classSelected)
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'classesSelect', 'searchManagerSelect.js');
    }
   	logger.trace('classesSelect() will be left');
}

function createSubClassMenu(classSelected) {
	try {
    	logger.trace('createSubClassMenu() has been called');
	    clearSubClassesDropMenus();
	    subClasses.subClassesMenu.options[subClasses.subClassesMenu.options.length] = new Option('All', 'All');
	    subClasses.subClassesMenu.selectedIndex = 0;
	    var classArray = subClassesMenu[classSelected];
	
	    if (classArray) {
	        for (var i = 0; i < classArray.length; i++) {
	            subClasses.subClassesMenu.options[subClasses.subClassesMenu.options.length] = new Option(classArray[i].name, classArray[i].id)
	        }
	    }
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'createSubClassMenu', 'searchManagerSelect.js');
    }
   	logger.trace('createSubClassMenu() will be left');
}

function subClassesSelect() {
	try {
    	logger.trace('subClassesSelect() has been called');
	    var subClassSelected = subClasses.subClassesMenu.options[subClasses.subClassesMenu.selectedIndex].text
	
	    if (subClassSelected == 'All') {
	        clearSubClassesDropMenus();
	        var detailId = document.getElementById('classInput');
	
	        if (detailId != null) {
	            document.getElementById('tCell' + 'classInput').removeChild(document.getElementById('classInput'))
	        }
	
	        subClasses.subClassesMenu.options[subClasses.subClassesMenu.options.length] = new Option('All', 'All');
	        subClasses.subClassesMenu.selectedIndex = 0;
	        classSelected = classes.classesMenu.options[classes.classesMenu.selectedIndex].text;
	        createSubClassMenu(classSelected);
	        createInputFields('classInput', classSelected);
	        return
	    }
	
	    createInputFields('classInput', subClassSelected)
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'subClassesSelect', 'searchManagerSelect.js');
    }
   	logger.trace('subClassesSelect() will be left');
}

function groupsSelect() {
	try {
    	logger.trace('groupsSelect() has been called');
	    var groupsSelected = groups.groupsMenu.options[groups.groupsMenu.selectedIndex].text
	
	    if (groupsSelected == 'All') {
	        var detailId = document.getElementById('groupInput');
	
	        if (detailId != null) {
	            document.getElementById('tCell' + 'groupInput').removeChild(document.getElementById('groupInput'));
	            return;
	        }
	    }
	
	    createInputFields('groupInput', groupsSelected + '_group');
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'groupsSelect', 'searchManagerSelect.js');
    }
   	logger.trace('groupsSelect() will be left');
}

function tagsSelect() {
	try {
    	logger.trace('tagsSelect() has been called');
	    var tagsSelected = tags.tagsMenu.options[tags.tagsMenu.selectedIndex].text;
	
	    if (tagsSelected == 'All') {
	        var detailId = document.getElementById('tagInput');
	
	        if (detailId != null) {
	            document.getElementById('tCell' + 'tagInput').removeChild(document.getElementById('tagInput'))
	            return
	        }
	    }
	
	    createInputFields('tagInput', tagsSelected)
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'tagsSelect', 'searchManagerSelect.js');
    }
   	logger.trace('tagsSelect() will be left');
}

function createInputFields(inputId, propId) {
	try {
    	logger.trace('createInputFields(' + inputId + ', ' + propId + ') has been called');
	    var propNodes = propertiesArray[propId];
logger.debug("propNodes: " + propNodes);
	    if (propNodes) {
		    var detailId = document.getElementById(inputId);
		
		    if (detailId != null) {
		        document.getElementById('tCell' + inputId).removeChild(document.getElementById(inputId))
		    }
		
		    var newForm = document.createElement("form");
		    newForm.style.setAttribute('cssText', 'border-color:#c2c2c2;border-width:4px;background-color:#c2c2c2;border-style : solid;font-family: verdana,arial,sans-serif;font-size:9pt;font-weight:bold;color:white;', 0);
		    newForm.setAttribute("id", inputId);
		
		    for (var i = 0; i < propNodes.length; i++) {
		        var textNode = document.createTextNode(propNodes[i].name);
		        newForm.appendChild(textNode);
		        var elem = document.createElement("br");
		        newForm.appendChild(elem);
		
		        if (propNodes[i].type == 'selection') {
		            var newField = document.createElement("select");
		            newField.setAttribute("name", propNodes[i].name)
		            var selectionList = propNodes[i].list.split(';')
		
		            for (var xx = 0; xx < selectionList.length; xx++) {
		                var theOption = document.createElement("option")
		                var theText = document.createTextNode(selectionList[xx]);
		                theOption.appendChild(theText);
		                theOption.setAttribute("value", selectionList[xx]);
		                newField.appendChild(theOption);
		            }
		
		            newForm.appendChild(newField);
		            var elem = document.createElement("br");
		            newForm.appendChild(elem);
		        }
		
		        if (propNodes[i].type != 'selection') {
		            var newField = document.createElement("input");
		            newField.setAttribute("type", "text");
		            newField.setAttribute("name", propNodes[i].name);
		            newField.setAttribute("size", "70");
		            newField.setAttribute("value", "");
		            newForm.appendChild(newField);
		            var elem = document.createElement("br");
		            newForm.appendChild(elem);
		        }
		    }
		
		    document.getElementById('tCell' + inputId).appendChild(newForm);
	    }
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'createInputFields', 'searchManagerSelect.js');
    }
   	logger.trace('createInputFields() will be left');
}

function assembleSearch() {
	try {
    	logger.trace('assembleSearch() has been called');
	    var searchXML = createXMLDocument();
	    //root
	    var searchRoot = searchXML.createElement("searchRequest")
	    searchXML.appendChild(searchRoot)
	    //---child 1
	    var searchCriteria = searchXML.createElement("searchCriteria")
	    searchRoot.appendChild(searchCriteria)
	
	    //class
	    var subClassSelected = subClasses.subClassesMenu.options[subClasses.subClassesMenu.selectedIndex].text
	    var classSelected = classes.classesMenu.options[classes.classesMenu.selectedIndex].text
	    var classValue = classes.classesMenu.options[classes.classesMenu.selectedIndex].value
	
	    if (classSelected != 'All') {
	        if (subClassSelected != 'All') {
	            var classValue = subClasses.subClassesMenu.options[subClasses.subClassesMenu.selectedIndex].value
	        }
	
	        var classElem = searchXML.createElement("class")
	        var searchClassNameAtt = searchXML.createAttribute("name")
	        classElem.setAttribute('name', "Class Properties")
	        searchClassNameAtt = searchXML.createAttribute("id")
	        classElem.setAttribute('id', classValue)
	        searchClassNameAtt = searchXML.createAttribute("link")
	
	        if (document.cRelationship.cRadio[0].checked) {
	            var linkValue = 'AND';
	        }
	        else {
	            var linkValue = 'OR';
	        }
	
	        classElem.setAttribute('link', linkValue);
	        searchCriteria.appendChild(classElem);
	        //class properties
	        var propList = document.getElementById("classInput");
	
	        if (propList) {
	            for (var i = 0; i < propList.length; i++) {
	                if (propList[i].value != "") {
	                    logger.info(' line 529 propList[i].type = ' + propList[i].type);
	
	                    if (propList[i].type == 'checkbox') {
	                        var chkd = document.getElementById("classInput")[i].checked;
	                        propList[i].value = chkd;
	                    }
	
	                    var classProperty = searchXML.createElement("Property");
	                    var classPropertyAtt = searchXML.createAttribute("name");
	                    classProperty.setAttribute('name', propList[i].name);
	                    classPropertyAtt = searchXML.createAttribute("value");
	
	                    if (propList[i].type == 'checkbox') {
	                        var chkd = document.getElementById("classInput")[i].checked;
	
	                        if (chkd == true) {
	                            chkd = 'true';
	                        }
	                        else {
	                            chkd = 'false';
	                        }
	                        classProperty.setAttribute('value', chkd);
	                    }
	                    else {
	                        classProperty.setAttribute('value', propList[i].value);
	                    }
	                    classElem.appendChild(classProperty);
	                }
	            }
	        }
	    }
	
	    //-------group
	    var groupsSelected = groups.groupsMenu.options[groups.groupsMenu.selectedIndex].text;
	    var groupsId = groups.groupsMenu.options[groups.groupsMenu.selectedIndex].value;
	
	    if (groupsSelected != 'All') {
	        var groupElem = searchXML.createElement("group");
	        var groupNameAtt = searchXML.createAttribute("name");
	        groupElem.setAttribute('name', "Group Properties");
	        groupNameAtt = searchXML.createAttribute("id");
	        groupElem.setAttribute('id', groupsId);
	        groupNameAtt = searchXML.createAttribute("link");

			// @D4D remove relationship for groups
	        searchCriteria.appendChild(groupElem);
	        //-------group properties
	
	        var propList = document.getElementById("groupInput");
	
	        if (propList) {
	            for (var i = 0; i < propList.length; i++) {
	                if (propList[i].value != "") {
	                    var groupProperty = searchXML.createElement("Property");
	                    var groupPropertyAtt = searchXML.createAttribute("name");
	                    groupProperty.setAttribute('name', propList[i].name);
	                    groupPropertyAtt = searchXML.createAttribute("value");
	
	                    if (propList[i].type == 'checkbox') {
	                        var chkd = document.getElementById("groupInput")[i].checked;
	
	                        if (chkd == true) {
	                            chkd = 'true';
	                        }
	                        else {
	                            chkd = 'false';
	                        }
	                        groupProperty.setAttribute('value', chkd);
	                    }
	                    else {
	                        groupProperty.setAttribute('value', propList[i].value);
	                    }
	                    groupElem.appendChild(groupProperty)
	                }
	            }
	        }
	    }
	
	    //-------tag
	    var tagsSelected = tags.tagsMenu.options[tags.tagsMenu.selectedIndex].text;
	
	    if (tagsSelected != 'All') {
	        var tagElem = searchXML.createElement("tag");
	        var tagNameAtt = searchXML.createAttribute("name");
	        tagElem.setAttribute('name', "Tag Properties");
	        tagNameAtt = searchXML.createAttribute("name");
	
	        if (document.tRelationship.tRadio[0].checked) {
	            var linkValue = 'AND';
	        }
	        else {
	            var linkValue = 'OR';
	        }
	
	        tagElem.setAttribute('link', linkValue);
	        searchCriteria.appendChild(tagElem);
	        //tag properties
	        var propList = document.getElementById("tagInput");
	
	        if (propList) {
	            for (var i = 0; i < propList.length; i++) {
	                if (propList[i].value != "") {
	                    var tagProperty = searchXML.createElement("Property");
	                    var tagPropertyAtt = searchXML.createAttribute("name");
	                    tagProperty.setAttribute('name', propList[i].name);
	                    tagPropertyAtt = searchXML.createAttribute("value");
	
	                    if (propList[i].type == 'checkbox') {
	                        var chkd = document.getElementById("tagInput")[i].checked;
	
	                        if (chkd == true) {
	                            chkd = 'true';
	                        }
	                        else {
	                            chkd = 'false';
	                        }
	
	                        tagProperty.setAttribute('value', chkd);
	                    }
	                    else {
	                        tagProperty.setAttribute('value', propList[i].value);
	                    }
	
	                    tagElem.appendChild(tagProperty)
	                }
	            }
	        }
	    }
	
	    //---
	    objPI = searchXML.createProcessingInstruction("xml", "version='1.0'");
	    searchXML.insertBefore(objPI, searchXML.childNodes(0));
	
	    logger.info('searchXML.xml \n' + searchXML.xml);
	    //---doSearch(searchUrl, "searchString="+"'"+searchXML.xml+"'")
	    doSearch(searchUrl, "searchString=" + searchXML.xml);
	    //---doSearch('http://ruit-b3.boeblingen.de.ibm.com:9080/SearchServlet/SearchServlet', "searchString="+searchXML.xml)
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'assembleSearch', 'searchManagerSelect.js');
    }
   	logger.trace('assembleSearch() will be left');
}

function resetSearch() {
	try {
    	logger.trace('resetSearch() has been called');
	    var searchResultForDisplay = new Object();
	    var classElement = document.getElementById('tCell' + 'classInput');
   	    if(classElement != null && document.getElementById('classInput') != null) {
	    	classElement.removeChild(document.getElementById('classInput'))
	    }
	    var groupElement = document.getElementById('tCell' + 'groupInput');
   	    if(groupElement != null && document.getElementById('groupInput') != null) {
	    	groupElement.removeChild(document.getElementById('groupInput'))
	    }
	    var tagElement = document.getElementById('tCell' + 'tagInput');
	    if(tagElement != null && document.getElementById('tagInput') != null) {
	    	tagElement.removeChild(document.getElementById('tagInput'))
	    }
	    var searchUrl = GetSearchCriteriaList;
		var searchParameters = "type=all";
		requestSearchLists(searchUrl, searchParameters);
	    if (window.opener) {
	        window.opener.catchSearchRowClick(searchResultForDisplay);
	    }
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'resetSearch', 'searchManagerSelect.js');
    }
   	logger.trace('resetSearch() will be left');
}

function resetSearchForm(formName) {
	try {
    	logger.trace('resetSearchForm(...) has been called');
	    var propList = document.getElementById(formName);
	
	    if (propList) {
	        for (var i = 0; i < propList.length; i++) {
	            if (propList[i].value != "") {
	                if (document.getElementById(formName)[i].type != 'select-one') { // prevent clearing of select lists
	                    document.getElementById(formName)[i].value = '';
	                }
	            }
	        }
	    }
	
	    var detailId = document.getElementById('container');
	
	    if (detailId != null) {
	        document.body.removeChild(document.getElementById('container'));
	    }
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'resetSearchForm', 'searchManagerSelect.js');
    }
   	logger.trace('resetSearchForm() will be left');
}

// ~20@D1D

function killSearch(thisBar) {
	try {
    	logger.trace('killSearch(...) has been called');
	    searchAjax.abort();
	    stopProgressBar(thisBar);
	    var msg = 'The doSearch function in searchManagerSelect.js\n'
	    msg += 'has been aborted because the time out for getting search data\r\n'
	    msg += 'returned from the server of 1.5 minutes was exceeded.\r\n';
	    logger.error(msg);
	    msg = translate("smg.requestAborted", new Array("SearchCriteria", 90000));
	    alert(msg);
	    return;
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'killSearch', 'searchManagerSelect.js');
    }
   	logger.trace('killSearch() will be left');
}

function searchManagerParseResult(searchResultsReport) {
    try {
    	logger.trace('searchManagerParseResult(...) has been called');
    	stopProgressBar(searchBarRef)
    	
        var detailId = document.getElementById('container');

        if (detailId != null) {
            document.body.removeChild(document.getElementById('container'))
        }

        var areaArray = new Array();
        var divElem = document.createElement("div");
        divElem.setAttribute("id", 'container');
        document.body.appendChild(divElem);
        var container = document.getElementById('container');

        var getList = searchResultsReport.getElementsByTagName("reportEntry");

        if (getList.length > 0)
        {
            for (var i = 0; i < getList.length; i++)
            {

                // -------Search Criteria goes here
                // -------

                if (getList[i].getAttribute('areaname'))
                {
                    areaArray[areaArray.length] = getList[i].getAttribute('areaname');
                    var textNode = document.createTextNode('Search Result For Area: ' + getList[i].getAttribute('areaname'));
                    container.appendChild(textNode);
                    var elem = document.createElement("br");

                    var newForm = document.createElement("form");
                    newForm.style.setAttribute('cssText', 'border-color:#c2c2c2;border-width:4px;background-color:#c2c2c2;border-style : solid; font-family: verdana,arial,sans-serif;font-size:9pt;font-weight:bold;color:white;',
                                               0);
                    newForm.setAttribute("id", getList[i].getAttribute('areaname') + '_form');
                    container.appendChild(newForm);
                }
                else
                {
                    var textNode = document.createTextNode('No results returned for this search criteria');
                    container.appendChild(textNode);
                    var elem = document.createElement("br");
                    return;
                }

                var reportClass = getList[i].getElementsByTagName("class");

                if (reportClass.length > 0)
                {
                    for (var j = 0; j < reportClass.length; j++) {
                        var cName = reportClass[j].getAttribute('name');

                        if (cName == null)
                        {
                            cName = 'None';
                        }

                        var textNode = document.createTextNode('Class Name: ' + cName);
                        newForm.appendChild(textNode);
                        var elem = document.createElement("br");
                        newForm.appendChild(elem);
                        var elem = document.createElement("br");
                        newForm.appendChild(elem);
                        container.appendChild(newForm);

                        var header = reportClass[j].getElementsByTagName("header");
                        var hdrs = header[0].attributes.length;
                        var rows = reportClass[j].getElementsByTagName("tagData");
                        var rowCount = rows.length;

                        if (hdrs > 0) {
                            var mytable = document.createElement("TABLE");
                            mytable.setAttribute("id", getList[i].getAttribute('areaname') + '_' + i);
                            mytable.style.setAttribute('cssText', 'font-family: verdana,arial,sans-serif;font-size:8pt;font-weight:normal;', 0);
                            var mytablebody = document.createElement("TBODY");
                            mytablebody.setAttribute("id", getList[i].getAttribute('areaname') + cName);
                            var currentRow = document.createElement("TR");

                            for (var h = 0; h < hdrs; h++) {
                                var currentCell = document.createElement("TD");
                                var cellText = document.createTextNode(header[0].attributes[h].text)
                                currentCell.appendChild(cellText);
                                currentRow.appendChild(currentCell);
                                currentRow.style.background = "#c2c2c2";
                            }

                            mytablebody.appendChild(currentRow);

                            for (var r = 0; r < rowCount; r++) {
                                var currentRow = document.createElement("TR");
                                var tagAtt = rows[r].attributes.length;
                                var concatxt = ''

                                for (var t = 0; t < tagAtt; t++) {
                                    concatxt += rows[r].attributes[t].name + '=' + rows[r].attributes[t].text + ' '
                                }

                                var currentCell = document.createElement("TD");
                                var cellText = document.createTextNode(concatxt);
                                currentCell.appendChild(cellText);
                                currentRow.appendChild(currentCell);
                                currentRow.style.background = "white";
                                var propNodes = rows[r].getElementsByTagName("Property");

                                if (propNodes) {
                                    for (var p = 0; p < propNodes.length; p++) {
                                        var propText = propNodes[p].getAttribute('value')
                                        var currentCell = document.createElement("TD");
                                        var cellText = document.createTextNode(propText)
                                        currentCell.appendChild(cellText);
                                        currentRow.appendChild(currentCell);
                                        currentRow.style.background = "white";
                                    }
                                }

                                mytablebody.appendChild(currentRow);
                            }

                            mytable.appendChild(mytablebody);
                            newForm.appendChild(mytable);
                            mytable.setAttribute("border", "1");
                        }

                        if (window.opener) {
                            stripeRows(areaArray, cName);
                            highlightRows(areaArray, cName);
                        }
                    }
                }

                var elem = document.createElement("br");
                container.appendChild(elem);
            }
        }
    }
    catch (errorObject) {
        handleException(errorObject, arguments, 'searchManagerParseResult', 'searchManagerSelect.js');
    }
   	logger.trace('searchManagerParseResult() will be left');
}

// 2methods@D1D

function transform() {
	try {
    	logger.trace('transform() has been called');
		initXSLT(false);  // @D2C
	    var expDate = 30; //days until expiration
	    setCookie('nameOfCookie', document.getElementById('pathName').value, expDate);
	    //function transform(source)
	    // create and load source document
	    var src = null;
	
	    if (searchAjax.resultData != null) {
	        src = createXMLDocument(searchAjax.resultData.responseText); //load xml
	    }
	    else {
	        alert(translate("smg.noResults2Display"));
	        return;
	    }
	
	    if (radioFileType == 'html') {
	        //retrieve cached XSLProcessor and transform the source document
	        var proc = cache.createProcessor();
	        proc.input = src;
	        proc.transform();
	        convReport = proc.output;
	    }
	
	    if (radioFileType == 'xml') {
	        convReport = src.xml;
	    }
	
	    var path = document.getElementById('pathName').value;
	    WriteReportToFile(path, 'test', radioFileType); // data, path, filename, text file ext. - xml, text, html
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'transform', 'searchManagerSelect.js');
    }
   	logger.trace('transform() will be left');
}

function WriteReportToFile(path, fname, ftype) {
	try {
    	logger.trace('WriteReportToFile() has been called');
	    if (path == "") {
	        path = getCurrentDirectory(); // replace this with text input field content
	    }
	
	    var filename = path + '.' + ftype;
	    var fso = new ActiveXObject("Scripting.FileSystemObject");
		
	    if (fso.FileExists(filename)) { //see if file exists, if it does,  confirm overwrite or cancel
	        var userChoice = confirm('The file -' + filename + ', already exists. Do you want to overwrite it?');
	
	        if (! userChoice) { // if user doesn't want to overwrite the file return
	            return;
	        }
	        else { //user wants to overwrite the file
		     	if (ftype == 'xml')
	        		 var file = fso.CreateTextFile(filename, true, -1);
	        	else
		            var file = fso.CreateTextFile(filename, true, -1);
	            //            var nd = new Date();
	            //            file.WriteLine("Report date:  " + nd);
	            file.WriteLine(convReport);
	            file.Close();
	            return;
	        }
	    }
	    else  {
			if (ftype == 'xml')
		    	var file = fso.CreateTextFile(filename, true, -1);
			else
				var file = fso.CreateTextFile(filename, true, -1);

	        //        var nd = new Date();
	        //        file.WriteLine("Report date:  " + nd);
	        file.WriteLine(convReport);
	        file.Close();
	    }
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'WriteReportToFile', 'searchManagerSelect.js');
    }
   	logger.trace('WriteReportToFile() will be left');
}

/**
 * Will be called onLoad and initializes the windows.
 * Transaltions will be done.
 */
function main() {
	try {
		logger = log4javascript.getNullLogger();
		requestLogging = window.opener.requestLogging;
		logger.trace('main() has been called');
		onerror = handleErrors;
		//maxWindow()
		//<---- required for logging	- logs are listed under admin name
		directory = getCurrentDirectory();
		loadPrefs();
		translateGUI();
		//----->
		//var searchUrl = "http://ruit-b3.boeblingen.de.ibm.com:9080/SearchCriteria/GetSearchCriteriaList"
		var searchUrl = GetSearchCriteriaList;
		var searchParameters = "type=all";
		requestSearchLists(searchUrl, searchParameters);
		//parseSearchLists('')
		initXSLT(true);  // @D2C
	}
	catch(errorObject) {
		handleException(errorObject, arguments, 'main', 'searchManagerSelect.js');
	}
	logger.trace('main() will be left');
}

/**
 * Closes the search window.
 */
function windowCloser() {
	try {
    	logger.trace('windowCloser() has been called');
		if (window.opener) {
	        window.opener.catchSearchWindowClose()
		}
	}
	catch (errorObject) {
    }
	logger.trace('windowCloser() will be left');
}

/**
 * Translates all elements (Buttons, Comboboxes,...) on the GUI (the current html-page).
 */
function translateGUI() {
	try {
	logger.trace('translateGUI() has been called');
	translateGuiElement('search.title', 'smg.search.title');
	translateGuiElement('search.classProperties', 'smg.search.classProperties');
	translateGuiElement('search.classes', 'smg.search.classes');
	translateGuiElement('search.subClasses', 'smg.search.subClasses');

	var element = document.getElementById('cRelationship');
	element.innerHTML = ' ' + translate('smg.search.relationship') + ' <input type="radio" name="cRadio" value="and" checked>' 
			+ translate('smg.and') + ' <input type="radio" name="cRadio" value="or">' + translate('smg.or');

	translateGuiElement('search.groupProperties', 'smg.search.groupProperties');
	translateGuiElement('search.groups', 'smg.search.groups');
	// @D4D delete translation for group relationship
	
	translateGuiElement('search.tagProperties', 'smg.search.tagProperties');
	translateGuiElement('search.tags', 'smg.search.tags');
	element = document.getElementById('tRelationship');
	element.innerHTML = ' ' + translate('smg.search.relationship') + ' <input type="radio" name="tRadio" value="and" checked>' 
			+ translate('smg.and') + ' <input type="radio" name="tRadio" value="or">' + translate('smg.or');
	
	translateGuiElement('submitSearch', 'smg.search.submitSearch');
	translateGuiElement('rSearch', 'smg.search.reset');
	translateGuiElement('search.saveResultsPath', 'smg.search.saveResultsPath');
	translateGuiElement('search.fileFormat', 'smg.search.fileFormat');
	translateGuiElement('saveAll', 'smg.search.saveAll');

	logger.trace('translateGUI() will be left');
	}
	catch(errorObject) {
		handleException(errorObject, arguments, 'translateGUI', 'searchManagerSelect.js');
	}
	logger.trace('translateGUI() will be left');
}

function doSearch(searchResultUrl, searchRequest) {
    try {
    	logger.trace('doSearch() has been called');
        if (window.opener) {
            var searchReplayMode = window.opener.replayMode;
            var searchReplayID = window.opener.replayID;

            if (searchReplayMode) {
                searchRequest += '&replayid=' + searchReplayID;
            }
        }
        var newSearchRequest = unescape(encodeURIComponent(searchRequest));
		searchAjax = new AjaxHandler();
		searchAjax.sendRequest(searchResultUrl, newSearchRequest, true, searchManagerParseResult);
        createProgressBar(searchBarRef, translate("smg.search.acquiringData"), 500, 90, 'killSearch(this.id)');
    }
    catch (errorObject) {
        handleException(errorObject, arguments, 'doSearch', 'searchManagerSelect.js');
    }
   	logger.trace('doSearch() will be left');
}

function stripeRows(areaArray, cName)
{
	try
    {
    	logger.trace('stripeRows() has been called');
        for (var z = 0; z < areaArray.length; z++)
        {
            var toggle = true;
            var elementOfInterest = document.getElementById(areaArray[z] + cName);
            // 3@D3A: elementOfInterest could be null if search returns a combination of inside a area and outside of any area nodes
			if (elementOfInterest != null)
			{ 
	            var rows = elementOfInterest.getElementsByTagName('tr');
	
	            for (var i = 0; i < rows.length; i++) {
	                toggle = ! toggle;
	
	                if (toggle == true) {
	                    rows[i].style.backgroundColor = '#DDDDDD' //'lightgreen';
	                }
	                else {
	                    rows[i].style.backgroundColor = 'white';
	                }
	            }
	        } // @D3A
        }
    }
    catch (errorObject) {
        handleException(errorObject, arguments, 'stripeRows', 'searchManagerSelect.js');
    }
   	logger.trace('stripeRows() will be left');
}

function highlightRows(areaArray, cName) {
    try {
    	logger.trace('highlightRows(...) has been called');
        for (var z = 0; z < areaArray.length; z++) {
            var elementOfInterest = document.getElementById(areaArray[z] + cName);
            //var thisArea = areaArray[z]
            // 3@D3A: elementOfInterest could be null if search returns a combination of inside a area and outside of any area nodes
			if (elementOfInterest != null)
			{             
	            var rows = elementOfInterest.getElementsByTagName('tr');
	
	            for (var i = 0; i < rows.length; i++) {
	                rows[i].onmouseover = function() {
	                    //this.style.fontWeight = 'bold';
	                    currentColor = this.style.backgroundColor
	                    this.style.backgroundColor = 'yellow';
	                }
	
	                rows[i].onmouseout = function() {
	                    //this.style.fontWeight = 'normal';
	                    this.style.backgroundColor = currentColor;
	                }
	
	                rows[i].onclick = function() {
	                    rowOnClickHandler(this, this.parentNode);
	                }
	            }
	        } // @D3A
        }
    }
    catch (errorObject) {
        handleException(errorObject, arguments, 'search.js', 'searchManagerSelect.js');
    }
    logger.trace('highlightRows() will be left');
}

function initXSLT(first) {  // @D2C
	try {
    	logger.trace('initXSLT() has been called');
	    if ((first == true)  &&  (getCookie('nameOfCookie') != null)) {  // @D2C
	        document.getElementById('pathName').value = getCookie('nameOfCookie');
	    }
	
	    // create and load XSLT stylesheet  must be free-threaded
	    ss = new ActiveXObject('MSXML2.FreeThreadedDOMDocument.3.0');
	    ss.async = false;
	    ss.load('js/search.xsl');
	    //create XSLTemplate object and compile stylesheet into it
	    cache = new ActiveXObject("Msxml2.XSLTemplate.3.0");
	    cache.stylesheet = ss;
	}
    catch(errorObject) {
        handleException(errorObject, arguments, 'initXSLT', 'searchManagerSelect.js');
    }
   	logger.trace('initXSLT() will be left');
}

function rowOnClickHandler(ref, pNode) {
    try {
    	logger.trace('rowOnClickHandler() has been called');
        var searchResultForDisplay = new Object;
        //get table body id - if selection is for all tags in a class this is the reference
        //the table for that class
        var tBody = (pNode.getAttribute("id"));
        //area name is subset of table name - extract area name from Table id
        var thisArea = (pNode.parentNode.getAttribute("id"))
        var lastPosition = thisArea.lastIndexOf("_");
        thisArea = thisArea.substring(0, lastPosition);
        //reference to all td's
        var getlist = ref.childNodes;
        //get reference to td 0 then get td 0's firstchild which is a textNode
        var temp = getlist[0].firstChild.nodeValue.split(/ /);
        //extract needed content = tagID
        var tagID = temp[0].split('=');

        if (typeof tagID[1] == 'undefined') {
            //this is a header so get complete list of tags
            var targetTableBody = document.getElementById(tBody);
            var rowList = targetTableBody.getElementsByTagName('tr');

            for (var z = 1; z < rowList.length; z++) {
                var getlist = rowList[z].childNodes;
                var temp = getlist[0].firstChild.nodeValue.split(/ /);
                var tagID = temp[0].split('=');
                //create property for each tag id
                searchResultForDisplay[tagID[1]] = true;
            }
        }
        else  {
            searchResultForDisplay[tagID[1]] = true;
        }

        searchResultForDisplay.area = thisArea;
        logger.info('This is the the area to switch to to display the current search selection/s -- thisArea = ' + thisArea);
        window.opener.catchSearchRowClick(searchResultForDisplay);
    }
    catch (errorObject) {
        handleException(errorObject, arguments, 'rowOnClickHandler', 'searchManagerSelect.js');
    }
    logger.trace('rowOnClickHandler() will be left');
}